﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGSaveLoadExceptionCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        string fileName = "savedCustomizations.xml";
        private void saveBtn_Click(object sender, RoutedEventArgs e)
        {
            if (File.Exists(fileName))
            {
                File.Delete(fileName);
            }

            using(FileStream fs = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.ReadWrite))
            {
                xdg1.SaveCustomizations(fs);                
            }
        }

        private void loadBtn_Click(object sender, RoutedEventArgs e)
        {
            if (File.Exists(fileName))
            {
                try
                {
                    using(FileStream fs = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.ReadWrite))
                    {
                        string error = null;
                        xdg1.LoadCustomizations(fs, true, out error, Infragistics.Windows.DataPresenter.CustomizationType.None);
                        System.Diagnostics.Debug.WriteLine(error);
                    }
                }
                catch(Exception ex)
                {

                }
            }
        }
    }
}
